# -*- coding: utf-8 -*-

#
#  Copyright 2014 Jérôme Colin, Jérôme Kerdreux, Telecom Bretagne.
#  
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  		
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  				
#  You should have received a copy of the GNU General Public License
#  along with this program. If not, see <http://www.gnu.org/licenses/>.
#  


MIXER_PADDING = 10

from xAAL.Core import XAALEngine
from xAAL.Devices import XAALDevice
from xAAL import config,tools


class Dumper(XAALDevice):
    def __init__(self):
        uuid = tools.getRandomUUID()
        XAALDevice.__init__(self,"dumper",uuid,None)
    
    def callBack(self,msg,dev=None):
        print "========= %s =========" % msg
        header = msg.getHeader()
        print "*****Header*****\t"        
        if 'devtype' in header: print "Devtype\t%s"  % header['devtype']
        if 'action' in header: print "Action: \t%s"   % header['action']
        if 'msgtype' in header: print "Msgtype: \t%s"  % header['msgtype']
        if 'version' in header: print "Version: \t%s"  % header['version']
        if 'cipher' in header: print "Cipher: \t%s"   % header['cipher']
        if 'siganture' in header: print "Signature: \t%s"% header['signature']
        if 'target' in header: print "Target: \t%s"   % header['target']
        if 'source' in header: print "Source: \t%s"   % header['source']
        
        if msg.getBody():
            print "*****Body*****\t"
            print "%s \t" %msg.getBody()
            

eng=XAALEngine()
dump=Dumper()            
eng.registerDevice(dump)
eng.registerCallBackHandler(dump.callBack)
eng.run()
