#!/usr/bin/python2
# -*- coding: utf-8 -*-

#  
#  Copyright 2014 Jerome Kerdreux, Telecom Bretagne.
#  
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  		
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  				
#  You should have received a copy of the GNU General Public License
#  along with this program. If not, see <http://www.gnu.org/licenses/>.
#  


MIXER_PADDING = 10


from xAAL.Core import XAALEngine
from xAAL.Messages import XAALMessage
import ujson as json 
import sys
from xAAL import tools
from xAAL import config 


def main():
    uuid = tools.getRandomUUID()
    print "My Temp UUID is : %s" % uuid
    target = sys.argv[1]

    app = XAALEngine()
    msg = XAALMessage()

    msg.setTarget(target)
    msg.setDevtype('cmdLineHack')
    msg.setMsgtype('request')
    msg.setAction(sys.argv[2])
    msg.setSource(uuid)
    msg.setCipher()
    msg.setSignature()
    txt={"msg":[msg.getHeader(),msg.getBody()]}
    data = json.encode(txt)
    app.getNetworkConnector().send(data)    


    filterADDR = [config.XAAL_BCAST_ADDR,uuid]

    cnt = 0 
    while 1:
        data = app.getNetworkConnector().getData()
        if data:
            msg = app.getMessageFactory().parseMSG(data) 
            if msg.getTarget() in filterADDR:
                if msg.getAction() != 'alive':
                    msg.dump()
                    break
        cnt=cnt+1
        if cnt > 20:
            print "No answer .. timeout"
            break
                
   



if __name__=='__main__':
    try:
        main()
    except KeyboardInterrupt:
        pass
