# -*- coding: utf-8 -*-

#  
#  Copyright 2014 Jérôme Colin, Jérôme Kerdreux, Philippe Tanguy, Telecom Bretagne.
#  
#  This file is part of xAAL.
#  
#  xAAL is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  		
#  xAAL is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#  				
#  You should have received a copy of the GNU Lesser General Public License
#  along with xAAL. If not, see <http://www.gnu.org/licenses/>.
#  


from SitePage import SitePage
from DeviceInfo import DeviceInfo
import cherrypy

class DeviceList(SitePage):
    
    def __init__(self,xaalBrowser=None):
        SitePage.__init__(self,'DeviceList',xaalBrowser=xaalBrowser)
        self.setTitle('List of devices')
        self.setMenuItem('devices')

    def getDeviceList(self):
        return self.xaalBrowser.getDeviceList()

    @cherrypy.expose
    def device(self,addr=None,action=None):
        page=DeviceInfo(xaalBrowser=self.xaalBrowser,deviceAddr=addr)
        if action:
            page.sendAction(action)
        return page.render()
