# -*- coding: utf-8 -*-

#  
#  Copyright 2014 Jérôme Colin, Jérôme Kerdreux, Philippe Tanguy, Telecom Bretagne.
#  
#  This file is part of xAAL.
#  
#  xAAL is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  		
#  xAAL is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#  				
#  You should have received a copy of the GNU Lesser General Public License
#  along with xAAL. If not, see <http://www.gnu.org/licenses/>.
#  


import cherrypy
import string

from mako.template import Template
from mako.lookup import TemplateLookup


lookup = TemplateLookup(directories=['templates'])


class SitePage:
    def __init__(self,template='default',xaalBrowser=None):
        self.template = template
        self.title = template
        self.menuItem = None
        self.xaalBrowser = xaalBrowser 

    def render(self):
        name = string.join([self.template,'mako'],'.')
        tmpl = lookup.get_template(name)
        return tmpl.render(page=self)

    def index(self):
        return self.render()

    def setTitle(self,value):
        self.title = value

    def getTitle(self):
        return "xAAL:" + self.title

    def getSelectedMenuItem(self,value):
        if self.menuItem == value :
            return "current_page_item"
        return ""

    def setMenuItem(self,value):
        self.menuItem = value

    index.exposed = True

