# -*- coding: utf-8 -*-

#  
#  Copyright 2014 Jérôme Colin, Jérôme Kerdreux, Philippe Tanguy, Telecom Bretagne.
#  
#  This file is part of xAAL.
#  
#  xAAL is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  		
#  xAAL is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#  				
#  You should have received a copy of the GNU Lesser General Public License
#  along with xAAL. If not, see <http://www.gnu.org/licenses/>.
#  


import cherrypy
try: import ujson as json
except ImportError: import json
from collections import deque
from ServerSentEvent import ServerSentEvent

class Subscribe(object):
    
    def __init__(self):
        self.data=None#deque()
        self.isAlive = False
    
    def alive(self,data):
        print "*********************************"
        print "alive"
        print "*********************************"
        self.isAlive=True

    def attributesChange(self,msg):
        print "*********************************"
        print "Attributes change"
        print "*********************************"
        #self.data.append(msg)
        self.data = msg

    @cherrypy.expose
    def devices(self):
        if self.isAlive:
            self.isAlive = False
            cherrypy.response.headers["Content-Type"] = "text/event-stream"
            return "data: "+ "alive" + "\n\n"
        else:
            ev = ServerSentEvent(data=str(None),event=None,id=None)
            cherrypy.response.headers["Content-Type"] = "text/event-stream"
            return ev.encode()

    @cherrypy.expose
    def device(self):
        #if len(self.data)>0:
        if self.data:
            msg = self.data#.popleft()
            data = msg.getBody()
            ev = ServerSentEvent(data=str(json.dumps(data)),event="event_"+str(msg.getSource()),id=None)
            cherrypy.response.headers["Content-Type"] = "text/event-stream"
            print ev.encode()
            return ev.encode()
        else:
            ev = ServerSentEvent(data=str(None),event=None,id=None)
            cherrypy.response.headers["Content-Type"] = "text/event-stream"
            print ev.encode()
            return ev.encode()

