<%inherit file="base.mako"/>

<%
data = page.getData()
devtype = page.getDevType()
address = page.getAddr()
schema = page.getSchemaJson()
specificMethods = page.getSpecificMethods()
defaultMethods = page.getDefaultMethods()
specificAttributes = page.getSpecificAttributes()
defaultAttributes = page.getDefaultAttributes()
eventName = page.getEventName()
%>

<h1>Device description</h1>
<ul>
	<li>Address: ${address}</li>
	% for parameter in data:
	% if parameter == 'parent':
		<li>${parameter}: <a href=/devices/device?addr=${data[parameter]}>${data[parameter]}</a></li>
	% elif parameter == 'devices':
		<% devices = data[parameter] %>
		% for device in devices:
		<li>${device}: <a href=/devices/device?addr=${devices[device]}>${devices[device]}</a></li>
		% endfor
	% else:
		<li>${parameter}: ${data[parameter]}</li>
	% endif
	% endfor
</ul>

<h1>Device attributes</h1>
<h2>Default attributes</h2>
% if defaultAttributes:
		<ul>
		% for attribute in defaultAttributes:
			% if attribute in data:
				<li>${attribute}: ${data[attribute]}</li>
			% else:
				<li>${attribute}: None</li>
			% endif
		% endfor
   		</ul>
% else:
	<p>No default attributes found for this device</p>
% endif
<h2>Specific attributes</h2>
% if specificAttributes:
		<ul id="attributes">
		% for attribute in specificAttributes:
			<li>${attribute}:<div id=${attribute}>None</div> </li>
		% endfor
   		</ul>
% else:
	<p>No specific attributes found for this device</p>
% endif

<h1>Device methods</h1>
<h2>Default methods</h2>
% if defaultMethods:
		<form method=post action = /devices/device?addr=${address}>
		% for method in defaultMethods:
	   		<button type="submit" name='action' value= ${method}> ${method}</button>
			<br/>
		% endfor
   		</form>
% else:
	<p>No methods found for this device</p>
% endif

<h2>Specific  methods</h2>
% if specificMethods:
		<form method=post action = /devices/device?addr=${address}>
		% for method in specificMethods:
	   		<button type="submit" name='action' value= ${method}> ${method}</button>
			<br/>
		% endfor
   		</form>
% else:
	<p>No methods found for this device</p>
% endif

<h1>Device schema</h1>
% if schema:
Schema Raw:</br>
<pre id="printSchema"></pre>
% else:
	<p>No schema available for this device</p>
% endif 

<script type="text/javascript">
	var schemaJson = ${schema};
	document.getElementById("printSchema").innerHTML = JSON.stringify(schemaJson, undefined, 2); // indentation level = 2
	
	if(typeof(EventSource) !== "undefined") {
		var uri = "/subscribe/device";
		var source = new EventSource(uri);
		var eventName = ${eventName};
		source.addEventListener(eventName, function(event) {
			var data = event.data;
			console.log(data);
			dataJson = JSON.parse(data);
			//var attributes =  document.getElementById("attributes");
			for (var key in dataJson){
				console.log(key);
				console.log(dataJson[key]);
					document.getElementById(key).innerHTML = dataJson[key];
				}
		},false);
	} else {
		document.getElementById("attributes").innerHTML = "Sorry, your browser does not support server-sent events...";
	}
</script>
