# -*- coding: utf-8 -*-
 
# 
#  Copyright 2014 Jérôme Colin, Jérôme Kerdreux, Philippe Tanguy Telecom Bretagne.
#  
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  		
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  				
#  You should have received a copy of the GNU General Public License
#  along with this program. If not, see <http://www.gnu.org/licenses/>.
#


import os
import ConfigParser
import time
import cherrypy

from pages.DeviceList import DeviceList
from pages.DeviceInfo import DeviceInfo
from pages.Subscribe import Subscribe
from pages.StaticPage import StaticPage

from XAALBrowser import XAALBrowser
from xAAL.Core import XAALEngine


#class Root(object):
#    pass


#def loadConfig():
#    cfg = ConfigParser.RawConfigParser()
#    cfg.read('xAALBrowser.cfg')
    # ... return xaalBrowser


def startxaalDevice(bus):
    """ Start xAAL device """
    #xaalBrowser = loadconfig()
    xaalBrowser = XAALBrowser('5b8cfcda-c6ac-4ac2-a68d-d433817c87da',bus)
    eng = XAALEngine()
    eng.setDevices([xaalBrowser,])
    eng.registerCallBackHandler(xaalBrowser.callBack)
    eng.start()
    return (xaalBrowser,eng)

def main():
    (xaalBrowser,eng) = startxaalDevice(cherrypy.engine)
    backtask = cherrypy.process.plugins.BackgroundTask(0.1,eng.loop)
    backtask.start()

    #root = Root()
    root = DeviceList(xaalBrowser)
    root.subscribe = Subscribe()
    root.devices = root 
    root.about = StaticPage('About xAAL Browser','about','about')

    cherrypy.tree.mount(root, '/', 'xAALBrowserIHM.conf')
    cherrypy.engine.subscribe('attributesChange', root.subscribe.attributesChange)
    cherrypy.engine.subscribe('alive', root.subscribe.alive)
    cherrypy.engine.start()
    cherrypy.engine.block()


if __name__=="__main__":
    main()
