# -*- coding: utf-8 -*-

#  
#  Copyright 2014, Jérôme Kerdreux, Philippe Tanguy, Telecom Bretagne.
#  
#  This file is part of xAAL.
# 
#  xAAL is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#		
#  xAAL is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#				
#  You should have received a copy of the GNU Lesser General Public License
#  along with xAAL. If not, see <http://www.gnu.org/licenses/>.
#

from EIBConnection import *
import struct
import select

POWER_ON_CMD = 129
POWER_OFF_CMD = 128
POWER_ON_STATE = -127
POWER_OFF_STATE = -128

class KNXConnector():
    def __init__(self):
        self.__co=EIBConnection()
        self.__co.EIBSocketURL("ip:localhost:1234")
        self.__co.EIBOpen_GroupSocket(0)
        self.__buf=EIBBuffer()

    def sendData(self,devAddr,action):
        print action
        print devAddr
        action=[0,action]
        self.__co.EIBSendGroup(devAddr,action)

    def getData(self):
        msg=None        
        r = select.select([self.__co.fd,],[],[],0.1)
        if r[0]:
            msg=self.receive()
        if msg and len(msg)==10:    
            s=struct.Struct('10b')
            msg=s.unpack(msg)
            return msg
        
    def receive(self):
        return self.__co.fd.recv(10240)

def displayEIBDError():
    print "You need to start eibd first"
    print "1- Use findknxusb in the terminal to know the usb address"
    print "2- Then start eibd (e.g. eibd --listen-tcp=1234 usb:2:10:1:0:0 where 2:10:1:0:0 is the usb address) see eibd --help for more options"

