# -*- coding: utf-8 -*-

#  
#  Copyright 2014, Jérôme Kerdreux, Philippe Tanguy, Telecom Bretagne.
#  
#  This file is part of xAAL.
# 
#  xAAL is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#		
#  xAAL is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#				
#  You should have received a copy of the GNU Lesser General Public License
#  along with xAAL. If not, see <http://www.gnu.org/licenses/>.
#

from xAAL.Devices import XAALDevice,XAALAttribute
import KNX

class KNXPowerRelay(XAALDevice):
    def __init__(self,recvAddr=None,sendAddr=None,address=None,parent=None):
        XAALDevice.__init__(self,devtype='powerrelay.basic',addr=address,parent=None)        
        self.__state=XAALAttribute('power',self,default="unknow")
        self.__recvAddr=recvAddr
        self.__sendAddr=sendAddr
        self.setVendorID("IHSEV")
        self.setProductID("ACTinBOX Classic")
        
    def on(self):
        self.getParent().sendKNX(devAddr=self.getSendAddr(),action=KNX.POWER_ON_CMD)
    on.exposed=True

    def off(self):
        self.getParent().sendKNX(devAddr=self.getSendAddr(),action=KNX.POWER_OFF_CMD)
    off.exposed=True
    
    def setState(self,value):
        self.__state.setValue(value)
        
    def getRecvAddr(self):
        return self.__recvAddr
    
    def getSendAddr(self):
        return self.__sendAddr
