# -*- coding: utf-8 -*-

#  
#  Copyright 2014 Jérôme Kerdreux, Philippe Tanguy, Telecom Bretagne.
#  
#  This file is part of xAAL.
#  
#  xAAL is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  		
#  xAAL is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#  				
#  You should have received a copy of the GNU Lesser General Public License
#  along with xAAL. If not, see <http://www.gnu.org/licenses/>.
#  


from xAAL.Devices import XAALAttribute

from gateways.ZWave.ZwaveDevice import ZwaveDevice


# Aeon labs home energy meter device
class AeoHem3(ZwaveDevice):
    def __init__(self,xaalAddr=None,devtype=None,manager=None,parent=None,homeId=None,nodeId=None):
        ZwaveDevice.__init__(self,xaalAddr=xaalAddr,devtype=devtype,manager=manager,homeId=homeId,nodeId=nodeId)
        self.setVendorID("IHSEV")
        self.setProductID("AEO_HEM3")

        self.__power1 = XAALAttribute('powerClamp1',self,default="unknown")

    def parseMsg(self,msg=None):
        ZwaveDevice.parseMsg(self,msg)
        notif = msg['notificationType']
        if notif == 'ValueChanged':
            if msg['valueId']['commandClass'] == 'COMMAND_CLASS_SENSOR_MULTILEVEL':
                if msg['valueId']['instance'] == 1:
                    value = msg['valueId']['value']
                    self.__power1.setValue(value)
                    print "*******************************************"
                    print "Power: %s" % value
                    print "*******************************************"

