# -*- coding: utf-8 -*-

#  
#  Copyright 2014 Jérôme Kerdreux, Philippe Tanguy, Telecom Bretagne.
#  
#  This file is part of xAAL.
#  
#  xAAL is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  		
#  xAAL is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#  				
#  You should have received a copy of the GNU Lesser General Public License
#  along with xAAL. If not, see <http://www.gnu.org/licenses/>.
#  


from xAAL.Devices import XAALAttribute
from gateways.ZWave.ZwaveDevice import ZwaveDevice


class Fgs211(ZwaveDevice):
    def __init__(self,xaalAddr=None,devtype=None,manager=None,parent=None,homeId=None,nodeId=None):
        ZwaveDevice.__init__(self,xaalAddr=xaalAddr,devtype=devtype,manager=manager,homeId=homeId,nodeId=nodeId)
        self.setVendorID("IHSEV")
        self.setProductID("Fibaro FGS-211")
        self.__power=XAALAttribute('power',self,default="unknown")
    
    def on(self):
        self.__power.setValue('on')
        id = self.getValueId(commandClass="COMMAND_CLASS_SWITCH_BINARY",instance=1) #We only use the switch 1...
        if id:
            self.setValue(id=id,value=1)

    on.exposed = True

    def off(self):
        self.__power.setValue('off')
        id = self.getValueId(commandClass="COMMAND_CLASS_SWITCH_BINARY",instance=1)
        if id:
            self.setValue(id=id,value=0)

    off.exposed = True

