#!/usr/bin/python2
# -*- coding: utf-8 -*-

import cjson
import sys
import argparse

from xAAL.Devices import XAALDevice
from xAAL.Core import XAALEngine
from xAAL.Messages import XAALMessage

#Parser
parser = argparse.ArgumentParser(description='Command line interface to query a xAAL cache device .')
parser.add_argument('--setTarget',
        type=str,
        required=True,
        help='xAAL device address')
parser.add_argument('--setAction',
        type=str,
        help='choose one method in the schema of the xAAL device target ;-)')
parser.add_argument('-a','--address',
        dest="address",
        help='add parameter address according to setAction if necessary')

args = parser.parse_args()

#Create xAALMetadataCLI device
metadataCLI = XAALDevice()
metadataCLI.setType('cmdLineHack')
metadataCLI.setAddress('b03d8f48-335f-4b43-9469-d8b016210cf3')

#Create message to send: msgTx
msgTx={}
msgTx["target"] = args.setTarget
msgTx["msgtype"] = 'request'
msgTx["action"] = args.setAction

body={}
if args.address:
    print type(args.address)
    body["address"] = args.address

if body:
    msgTx["body"]=body

#Create engine
eng = XAALEngine()
#eng.addDevice(metadataCLI)

#Send msgTx
eng.send(dev=metadataCLI,**msgTx)
